aclexplode
==========

The main purpse of aclexplode function is to convert the relacl array from
pg_class row into the new representation, that can be easily parsed or
interpreted by the user. Each result row consists of grantor and grantee OIDs,
text description of the given privilege (i.e INSERT, TRUNCATE and so on) and a
flag, defining whether the grantee is allowed to grant the privilege to another
role.

This module was sponsored by Enova Financial (http://www.enova.com)

To build aclexplode, just do this:

    make
    make installcheck
    make install

If you encounter an error such as:

    "Makefile", line 8: Need an operator

You need to use GNU make, which may well be installed on your system as
`gmake`:

    gmake
    gmake install
    gmake installcheck

If you encounter an error such as:

    make: pg_config: Command not found

Be sure that you have `pg_config` installed and in your path. If you used a
package management system such as RPM to install PostgreSQL, be sure that the
`-devel` package is also installed. If necessary tell the build process where
to find it:

    env PG_CONFIG=/path/to/pg_config make && make installcheck && make install

And finally, if all that fails (and if you're on PostgreSQL 8.1 or lower, it
likely will), copy the entire distribution directory to the `contrib/`
subdirectory of the PostgreSQL source tree and try it there without
`pg_config`:

    env NO_PGXS=1 make && make installcheck && make install

If you encounter an error such as:

    ERROR:  must be owner of database regression

You need to run the test suite using a super user, such as the default
"postgres" super user:

    make installcheck PGUSER=postgres

Warning: generally, there is no point in installing aclexplode on anything
newer than 8.4, since PostgreSQL 9.0 already have built-in aclexplode function.
Once aclexplode is installed, you can add it to a database. If you're running
PostgreSQL 9.1.0 or greater, it's a simple as connecting to a database as a
super user and running:

    CREATE EXTENSION aclexplode;

If you've upgraded your cluster to PostgreSQL 9.1 and already had aclexplode
installed, you can upgrade it to a properly packaged extension with:

    CREATE EXTENSION aclexplode FROM unpackaged;

For versions of PostgreSQL less than 9.1.0, you'll need to run the
installation script:

    psql -d mydb -f /path/to/pgsql/share/contrib/aclexplode.sql

If you want to install aclexplode and all of its supporting objects into a specific
schema, use the `PGOPTIONS` environment variable to specify the schema, like
so:

    PGOPTIONS=--search_path=extensions psql -d mydb -f aclexplode.sql

Dependencies
------------
The `aclexplode` data type has no dependencies other than PostgreSQL.

Copyright and License
---------------------

Copyright (c) 2012 Command Prompt, Inc.

